{-# OPTIONS_GHC -fno-warn-missing-signatures #-}
module Lib.MonoFunctor.Test where

import Test.Tasty

import Data.Proxy (Proxy(..))
import Prelude hiding (zipWith)
import qualified Data.MonoTraversable as MT

import Language.Symantic.Lib
import Compiling.Test

type SS =
 [ Proxy (->)
 , Proxy []
 , Proxy Integer
 , Proxy Bool
 , Proxy Char
 , Proxy MT.MonoFunctor
 , Proxy Maybe
 ]
(==>) = readTe @() @SS

tests :: TestTree
tests = testGroup "MonoFunctor"
 [ "omap not (Just True)" ==> Right (tyMaybe tyBool, Just False, "omap (\\x0 -> not x0) (Just True)")
 , "omap Char.toUpper ['a', 'b', 'c']" ==> Right (tyList tyChar, "ABC", "omap (\\x0 -> Char.toUpper x0) ('a' : 'b' : 'c' : [])" )
 ]
